# Copyright (c) 2021 Project CHIP Authors
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

name:
    24.1.10. [TC-CADMIN-1.10] Device exit commissioning mode after 20 failed
    commission attempts [BCM] [DUT - Commissionee]

PICS:
    - CADMIN.S
    - CADMIN.S.F00

config:
    nodeId: 0x12344321
    timeout: 700
    nodeIdForDuplicateCommissioning:
        type: node_id
        defaultValue: 0x11
    nodeId2:
        type: node_id
        defaultValue: 0xCAFE
    nodeId3:
        type: node_id
        defaultValue: 0xC00FEE
    endpoint: 0
    waitAfterCommissioning:
        type: int16u
        defaultValue: 5000
    correctPayload:
        type: char_string
        defaultValue: "MT:-24J0AFN00KA0648G00"
    incorrectSetupCodePayload:
        type: char_string
        defaultValue: "MT:-24J0AFN00I.0648G00"
    PIXIT.CADMIN.CwDuration:
        type: int16u
        defaultValue: 180

tests:
    - label: "Precondition: Reset Devices to factory defaults"
      PICS: PICS_SDK_CI_ONLY
      cluster: "SystemCommands"
      command: "FactoryReset"

    - label: "Precondition: Reset Devices to factory defaults"
      verification: |
          Reset Devices to factory defaults
      cluster: "LogCommands"
      command: "UserPrompt"
      PICS: PICS_SKIP_SAMPLE_APP
      arguments:
          values:
              - name: "message"
                value: "Factory Reset the DUT and enter 'y' after success"
              - name: "expectedValue"
                value: "y"

    - label: "Step 1: TH_CR1 starts a commissioning process with DUT_CE"
      cluster: "CommissionerCommands"
      command: "PairWithCode"
      PICS: CADMIN.S
      arguments:
          values:
              - name: "nodeId"
                value: nodeId
              - name: "payload"
                value: correctPayload

    - label: "Step 1a: TH_CR1 commissioned with DUT_CE"
      cluster: "DelayCommands"
      command: "WaitForCommissionee"
      PICS: CADMIN.S
      arguments:
          values:
              - name: "nodeId"
                value: nodeId

    - label:
          "Step 2: TH_CR1 opens a commissioning window on DUT_CE using a
          commissioning timeout of PIXIT.CADMIN.CwDuration seconds using BCM"
      cluster: "Administrator Commissioning"
      command: "OpenBasicCommissioningWindow"
      PICS: CADMIN.S.C01.Rsp
      timedInteractionTimeoutMs: 10000
      arguments:
          values:
              - name: "CommissioningTimeout"
                value: PIXIT.CADMIN.CwDuration

    - label: "Step 2a: Waiting after opening commissioning window"
      PICS: CADMIN.S.C01.Rsp
      cluster: "DelayCommands"
      command: "WaitForMs"
      arguments:
          values:
              - name: "ms"
                value: waitAfterCommissioning

    - label: "Step 3: Verify that the DNS-SD advertisement shows CM=1"
      PICS: CADMIN.S.C01.Rsp
      cluster: "DiscoveryCommands"
      command: "FindCommissionable"
      response:
          values:
              - name: "commissioningMode"
                value: 1

    #As per issue https://github.com/CHIP-Specifications/chip-test-scripts/issues/495 adding --discover-once flag
    - label:
          "Step 4.1: Before the expiration of PIXIT.CADMIN.CwDuration set in
          step 2, set up a TH_CR2 to start attempting to do PASE to DUT_CE and
          failing 20 times. This can be done using a valid onboarding payload
          with an incorrect setupcode"
      identity: "beta"
      cluster: "CommissionerCommands"
      command: "PairWithCode"
      PICS: CADMIN.S
      arguments:
          values:
              - name: "nodeId"
                value: nodeId2
              - name: "payload"
                value: incorrectSetupCodePayload
              - name: discoverOnce
                value: true
      response:
          error: FAILURE

    - label:
          "Step 4.2: TH_CR2 starts a commissioning process with DUT_CE using
          Invalid setup code"
      identity: "beta"
      cluster: "CommissionerCommands"
      command: "PairWithCode"
      PICS: CADMIN.S
      arguments:
          values:
              - name: "nodeId"
                value: nodeId2
              - name: "payload"
                value: incorrectSetupCodePayload
              - name: discoverOnce
                value: true
      response:
          error: FAILURE

    - label:
          "Step 4.3: TH_CR2 starts a commissioning process with DUT_CE using
          Invalid setup code"
      identity: "beta"
      cluster: "CommissionerCommands"
      command: "PairWithCode"
      PICS: CADMIN.S
      arguments:
          values:
              - name: "nodeId"
                value: nodeId2
              - name: "payload"
                value: incorrectSetupCodePayload
              - name: discoverOnce
                value: true
      response:
          error: FAILURE

    - label:
          "Step 4.4: TH_CR2 starts a commissioning process with DUT_CE using
          Invalid setup code"
      identity: "beta"
      cluster: "CommissionerCommands"
      command: "PairWithCode"
      PICS: CADMIN.S
      arguments:
          values:
              - name: "nodeId"
                value: nodeId2
              - name: "payload"
                value: incorrectSetupCodePayload
              - name: discoverOnce
                value: true
      response:
          error: FAILURE

    - label:
          "Step 4.5: TH_CR2 starts a commissioning process with DUT_CE using
          Invalid setup code"
      identity: "beta"
      cluster: "CommissionerCommands"
      command: "PairWithCode"
      PICS: CADMIN.S
      arguments:
          values:
              - name: "nodeId"
                value: nodeId2
              - name: "payload"
                value: incorrectSetupCodePayload
              - name: discoverOnce
                value: true
      response:
          error: FAILURE

    - label:
          "Step 4.6: TH_CR2 starts a commissioning process with DUT_CE using
          Invalid setup code"
      identity: "beta"
      cluster: "CommissionerCommands"
      command: "PairWithCode"
      PICS: CADMIN.S
      arguments:
          values:
              - name: "nodeId"
                value: nodeId2
              - name: "payload"
                value: incorrectSetupCodePayload
              - name: discoverOnce
                value: true
      response:
          error: FAILURE

    - label:
          "Step 4.7: TH_CR2 starts a commissioning process with DUT_CE using
          Invalid setup code"
      identity: "beta"
      cluster: "CommissionerCommands"
      command: "PairWithCode"
      PICS: CADMIN.S
      arguments:
          values:
              - name: "nodeId"
                value: nodeId2
              - name: "payload"
                value: incorrectSetupCodePayload
              - name: discoverOnce
                value: true
      response:
          error: FAILURE

    - label:
          "Step 4.8: TH_CR2 starts a commissioning process with DUT_CE using
          Invalid setup code"
      identity: "beta"
      cluster: "CommissionerCommands"
      command: "PairWithCode"
      PICS: CADMIN.S
      arguments:
          values:
              - name: "nodeId"
                value: nodeId2
              - name: "payload"
                value: incorrectSetupCodePayload
              - name: discoverOnce
                value: true
      response:
          error: FAILURE

    - label:
          "Step 4.9: TH_CR2 starts a commissioning process with DUT_CE using
          Invalid setup code"
      identity: "beta"
      cluster: "CommissionerCommands"
      command: "PairWithCode"
      PICS: CADMIN.S
      arguments:
          values:
              - name: "nodeId"
                value: nodeId2
              - name: "payload"
                value: incorrectSetupCodePayload
              - name: discoverOnce
                value: true
      response:
          error: FAILURE

    - label:
          "Step 4.10: TH_CR2 starts a commissioning process with DUT_CE using
          Invalid setup code"
      identity: "beta"
      cluster: "CommissionerCommands"
      command: "PairWithCode"
      arguments:
          values:
              - name: "nodeId"
                value: nodeId2
              - name: "payload"
                value: incorrectSetupCodePayload
              - name: discoverOnce
                value: true
      response:
          error: FAILURE

    - label:
          "Step 4.11: TH_CR2 starts a commissioning process with DUT_CE using
          Invalid setup code"
      identity: "beta"
      cluster: "CommissionerCommands"
      command: "PairWithCode"
      PICS: CADMIN.S
      arguments:
          values:
              - name: "nodeId"
                value: nodeId2
              - name: "payload"
                value: incorrectSetupCodePayload
              - name: discoverOnce
                value: true
      response:
          error: FAILURE

    - label:
          "Step 4.12: TH_CR2 starts a commissioning process with DUT_CE using
          Invalid setup code"
      identity: "beta"
      cluster: "CommissionerCommands"
      command: "PairWithCode"
      PICS: CADMIN.S
      arguments:
          values:
              - name: "nodeId"
                value: nodeId2
              - name: "payload"
                value: incorrectSetupCodePayload
              - name: discoverOnce
                value: true
      response:
          error: FAILURE

    - label:
          "Step 4.13: TH_CR2 starts a commissioning process with DUT_CE using
          Invalid setup code"
      identity: "beta"
      cluster: "CommissionerCommands"
      command: "PairWithCode"
      PICS: CADMIN.S
      arguments:
          values:
              - name: "nodeId"
                value: nodeId2
              - name: "payload"
                value: incorrectSetupCodePayload
              - name: discoverOnce
                value: true
      response:
          error: FAILURE

    - label:
          "Step 4.14: TH_CR2 starts a commissioning process with DUT_CE using
          Invalid setup code"
      identity: "beta"
      cluster: "CommissionerCommands"
      command: "PairWithCode"
      PICS: CADMIN.S
      arguments:
          values:
              - name: "nodeId"
                value: nodeId2
              - name: "payload"
                value: incorrectSetupCodePayload
              - name: discoverOnce
                value: true
      response:
          error: FAILURE

    - label:
          "Step 4.15: TH_CR2 starts a commissioning process with DUT_CE using
          Invalid setup code"
      identity: "beta"
      cluster: "CommissionerCommands"
      command: "PairWithCode"
      PICS: CADMIN.S
      arguments:
          values:
              - name: "nodeId"
                value: nodeId2
              - name: "payload"
                value: incorrectSetupCodePayload
              - name: discoverOnce
                value: true
      response:
          error: FAILURE

    - label:
          "Step 4.16: TH_CR2 starts a commissioning process with DUT_CE using
          Invalid setup code"
      identity: "beta"
      cluster: "CommissionerCommands"
      command: "PairWithCode"
      PICS: CADMIN.S
      arguments:
          values:
              - name: "nodeId"
                value: nodeId2
              - name: "payload"
                value: incorrectSetupCodePayload
              - name: discoverOnce
                value: true
      response:
          error: FAILURE

    - label:
          "Step 4.17: TH_CR2 starts a commissioning process with DUT_CE using
          Invalid setup code"
      identity: "beta"
      cluster: "CommissionerCommands"
      command: "PairWithCode"
      PICS: CADMIN.S
      arguments:
          values:
              - name: "nodeId"
                value: nodeId2
              - name: "payload"
                value: incorrectSetupCodePayload
              - name: discoverOnce
                value: true
      response:
          error: FAILURE

    - label:
          "Step 4.18: TH_CR2 starts a commissioning process with DUT_CE using
          Invalid setup code"
      identity: "beta"
      cluster: "CommissionerCommands"
      command: "PairWithCode"
      PICS: CADMIN.S
      arguments:
          values:
              - name: "nodeId"
                value: nodeId2
              - name: "payload"
                value: incorrectSetupCodePayload
              - name: discoverOnce
                value: true
      response:
          error: FAILURE

    - label:
          "Step 4.19: TH_CR2 starts a commissioning process with DUT_CE using
          Invalid setup code"
      identity: "beta"
      cluster: "CommissionerCommands"
      command: "PairWithCode"
      PICS: CADMIN.S
      arguments:
          values:
              - name: "nodeId"
                value: nodeId2
              - name: "payload"
                value: incorrectSetupCodePayload
              - name: discoverOnce
                value: true
      response:
          error: FAILURE

    - label:
          "Step 4.20: TH_CR2 starts a commissioning process with DUT_CE using
          Invalid setup code"
      identity: "beta"
      cluster: "CommissionerCommands"
      command: "PairWithCode"
      PICS: CADMIN.S
      arguments:
          values:
              - name: "nodeId"
                value: nodeId2
              - name: "payload"
                value: incorrectSetupCodePayload
              - name: discoverOnce
                value: true
      response:
          error: FAILURE

    # This step must match the verification step above where we checked `correctPayload`
    - label:
          "Step 5a: Before the expiration of PIXIT.CADMIN.CwDuration set in step
          2, TH_CR2 attempts to do PASE to DUT_CE using the correct onboarding
          payload"
      identity: "beta"
      cluster: "CommissionerCommands"
      command: "PairWithCode"
      PICS: CADMIN.S
      arguments:
          values:
              - name: "nodeId"
                value: nodeId2
              - name: "payload"
                value: correctPayload
      response:
          error: FAILURE

    - label: "Step 5b: TH_CR3 starts a commissioning process with DUT_CE"
      identity: "gamma"
      cluster: "CommissionerCommands"
      command: "PairWithCode"
      PICS: CADMIN.S
      arguments:
          values:
              - name: "nodeId"
                value: nodeId3
              - name: "payload"
                value: correctPayload
      response:
          error: FAILURE
